// STC8G1K08A 单节18650锂电供电,4V时空白的芯片电流为1.7mA,烧录程序后为2.5mA（烧录时选12MHz频率）                                
// 电位器中点接P5.5口取样，调节电位器，P3.3脚出1%--100%占空比脉冲
// 因为有ADC读取时间，输出有间或异常！
#include <STC8G.h>
#include <intrins.H>
#define uchar unsigned char 
#define uint unsigned int   
#define ADC_POWER   0x80 //ADC 电源控制位
#define ADC_FLAG    0x10 //ADC 转换结束标志位
#define ADC_START   0x08 //ADC 开始转换控制位
#define ADC_SPEEDLL 0x00 //210 个时钟周期转换一次
#define ADC_SPEEDL  0x20 //420 个时钟周期转换一次
#define ADC_SPEEDH  0x40 //630 个时钟周期转换一次
#define ADC_SPEEDHH 0x60 //840 个时钟周期转换一次
/********************************************************************
		初始定义
*********************************************************************/
uint tcnt=0;
uint sec=0;
uint dat=0;
uint dat1=0;
uint dat2=0;
uint K;

/********************************************************************
		I/O定义
*********************************************************************/
sbit Y0=P3^3; // PWM输出端1%--100%占空比
uchar CLK=0;  // 脉冲计数
/********************************************************************
		定时器T0初始化
*********************************************************************/
void timer0_init(){
AUXR &= 0x7F;  //定时器时钟12T模式
TMOD &= 0xF0;  //设置定时器模式
TMOD |= 0x02;  //设置定时器模式
TL0   = 0xF6;  //设置定时初始值
TH0   = 0xF6;  //设置定时重载值
TR0=1; 				 //开始定时
ET0=1;
EA=1;
}
void InitADC(){
ADC_RES = 0; 													//AD数据寄存器清空
ADC_CONTR = ADC_POWER | ADC_SPEEDLL; 	//打开AD电源，转换周期210
_nop_();
_nop_();
_nop_(); 
}

/********************************************************************
		主函数
*********************************************************************/
void main(){
		P3M0 = 0xff; P3M1 = 0x00; //推挽输出，可以高电平驱动LED，配合PWM有明暗变化
		P5M0 = 0x00; P5M1 = 0x00;    
		P32=0; // 方便接LED
		InitADC(); 				//AD初始化
		ADCCFG = 0x0f; 		//设置ADC时钟为系统时钟/2/16/16
		ADC_CONTR = 0x80; //使能ADC模块
		timer0_init();
		while(1){
			ADC_CONTR |= 0x45;  //启动AD转换 后一位数值5表示选择 ADC5，即P5.5
				_nop_();
				_nop_();
				while (!(ADC_CONTR & 0x20)); //查询ADC完成标志
				ADC_CONTR &= ~0x20; //清完成标志
				dat = ADC_RES; //读取ADC结果高8位，实际是第B0和B1有用
				dat1= ADC_RESL;//读取ADC结果低8位，8个位都有用
				K=(dat*256+dat1)/500;//4v串联2K到10K电位器上端子，下端子接地，中点接P5.4口取样
		}
}

/********************************************************************
		定时器T0中断服务函数
*********************************************************************/
void t0(void) interrupt 1 using 0 {   //定时中断服务函数250US一次中断
		if(K>0){       //K越大，占空比越大
				if(tcnt==0)  Y0=1; 
				if(tcnt==K)  Y0=0;
				tcnt++;    
				if(tcnt>100)  tcnt=0;
		}
}
